<cfcomponent>
	<cffunction name="getChannel" access="public" output="false" returntype="query">
		<cfargument name="channel_id" type="string" required="no" default="0">
		<cfargument name="site_id" type="string" required="no" default="0">
		<cfargument name="parent_channel_id" type="string" required="no" default="0">
		<cfargument name="fields" type="string" required="no" default="*">
		<cfargument name="max" type="string" required="no" default="100000">
		<cfargument name="order_by" type="string" required="no" default="created DESC">
            <cfquery datasource="#application.DB#" name="GetChannel" maxrows="#arguments.max#">
                SELECT * FROM ice_channel 
WHERE 0=0
<cfif isdefined("form.ice_channel")>AND ice_channel LIKE '%#form.ice_channel#%'</cfif>
<cfif isdefined("form.ice_user_id") AND form.ice_user_id IS NOT 0>AND ice_user_id=#form.ice_user_id#</cfif>
<cfif isdefined("form.ice_status_id") AND form.ice_status_id IS NOT 0>AND ice_status_id=#form.ice_status_id#</cfif>
<cfif isdefined("form.ice_site_language_id") AND form.ice_site_language_id IS NOT 0>AND ice_site_language_id=#form.ice_site_language_id#</cfif>
<cfif isdefined("form.ice_channel_label")>
<cfif isdefined("form.ice_channel_id") AND form.ice_channel_id IS NOT 0>AND id=#form.ice_channel_id#</cfif>
<cfelse>
<cfif isdefined("form.ice_channel_id") AND form.ice_channel_id IS NOT 0>AND id=#form.ice_channel_id#</cfif>
</cfif>
<cfif arguments.site_id IS 0><cfif isdefined("session.current_site_id")><cfset arguments.site_id=session.current_site_id><cfelseif isdefined("session.my_site_id")><cfset arguments.site_id=session.my_site_id></cfif></cfif>
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT  0>AND ice_site_id IN (#arguments.site_id#)</cfif>
<cfif isdefined("arguments.id") AND arguments.id IS NOT  0>AND id IN (#arguments.id#)</cfif>
<cfif isdefined("arguments.channel_id") AND arguments.channel_id IS NOT  0>AND id IN (#arguments.channel_id#)</cfif>
<cfif isdefined("arguments.parent_channel_id") AND arguments.parent_channel_id IS NOT  0>AND id = #arguments.parent_channel_id#</cfif>
<cfif isdefined("arguments.ice_status_id") AND arguments.ice_status_id IS NOT  0>AND ice_status_id IN (#arguments.ice_status_id#)</cfif>
<cfif isdefined("arguments.ice_site_language_id") AND arguments.ice_site_language_id IS NOT  0>AND ice_site_language_id = #arguments.ice_site_language_id#</cfif>
ORDER BY #arguments.order_by#
            </cfquery>
		<cfreturn GetChannel>
	</cffunction>

	<cffunction name="getChannelXML" access="public" output="false" returntype="xml">
		<cfargument name="channel_id" type="string" required="no" default="0">
		<cfargument name="site_id" type="string" required="no" default="0">
		<cfargument name="parent_channel_id" type="string" required="no" default="0">
		<cfargument name="fields" type="string" required="no" default="*">
		<cfargument name="max" type="string" required="no" default="100000">
		<cfargument name="order_by" type="string" required="no" default="created DESC">
            <cfquery datasource="#application.DB#" name="GetChannelXML" maxrows="#arguments.max#">
                SELECT * FROM ice_channel 
WHERE 0=0
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT  0>AND ice_site_id IN (#arguments.site_id#)</cfif>
<cfif isdefined("arguments.channel_id") AND arguments.channel_id IS NOT 0>AND id IN (#arguments.channel_id#)</cfif>
<cfif isdefined("arguments.id") AND arguments.id IS NOT  0>AND id = #arguments.id#</cfif>
<cfif isdefined("arguments.channel_id") AND arguments.channel_id IS NOT  0>AND id IN (#arguments.channel_id#)</cfif>
<cfif isdefined("arguments.parent_channel_id") AND arguments.parent_channel_id IS NOT  0>AND id = #arguments.parent_channel_id#</cfif>
<cfif isdefined("arguments.ice_status_id") AND arguments.ice_status_id IS NOT  0>AND ice_status_id IN (#arguments.ice_status_id#)</cfif>
<cfif isdefined("form.ice_site_language_id") AND form.ice_site_language_id IS NOT 0>AND ice_site_language_id=#form.ice_site_language_id#</cfif>
<cfif isdefined("arguments.ice_site_language_id") AND arguments.ice_site_language_id IS NOT  0>AND ice_site_language_id = #arguments.ice_site_language_id#</cfif>
ORDER BY #arguments.order_by#
            </cfquery>

		<cfif GetChannelXML.RecordCount IS 0>
<cfxml variable="XMLResult">
<channel>
<result>None found!</result>
</channel>
</cfxml>	
		<cfelse>
<cfprocessingdirective suppresswhitespace="Yes">
<cfxml variable="XMLResult">
<ice>
<cfoutput query="GetChannelXML">
<channel>
<id>#id#</id>
<ice_channel>#ice_channel#</ice_channel>
<folder>#folder#</folder>
<ice_channel_type_id>#ice_channel_type_id#</ice_channel_type_id>
<ice_site_id>#ice_site_id#</ice_site_id>
<cfinvoke component="site" method="getSites" site_id="#ice_site_id#" fields="ice_site,folder"  returnvariable="site">
<ice_site>#site.ice_site#</ice_site>
<ice_user_id>#ice_user_id#</ice_user_id>
<cfinvoke component="user" method="getUser" user_id="#ice_user_id#" fields="ice_user,photo"  returnvariable="user">
<ice_user>#user.ice_user#</ice_user>
<photo>#application.ice_url#/photos/#user.photo#</photo>
<rank>#rank#</rank>
<parent_channel_id>#ice_channel_id#</parent_channel_id>
<cfif ice_channel_id IS NOT 0>
<cfinvoke component="channel" method="getOtherChannel" channel_id="#ice_channel_id#" fields="ice_channel,folder,published_file"  returnvariable="channel">
<parent_channel>#channel.ice_channel#</parent_channel>
<parent_channel_folder>#channel.folder#</parent_channel_folder>
<parent_channel_published_file>#application.ice_url#/sites/#site.folder#/p/#channel.published_file#</parent_channel_published_file>
<cfelse>
<parent_channel></parent_channel>
<parent_channel_folder></parent_channel_folder>
<parent_channel_published_file></parent_channel_published_file>
</cfif>
<created>#created#</created>
<published_file>#application.ice_url#/sites/#site.folder#/p/#published_file#</published_file>
<ice_status_id>#ice_status_id#</ice_status_id>
</channel>
</cfoutput>
</ice>
</cfxml>	
</cfprocessingdirective>
		</cfif>
		<cfreturn XMLResult>
	</cffunction>

	<cffunction name="countChannel" access="public" output="false" returntype="numeric">
		<cfargument name="fields" type="string" required="no" default="id">
            <cfquery datasource="#application.DB#" name="CountChannel">
                SELECT #arguments.fields# FROM ice_channel 
WHERE 0=0
<cfif isdefined("arguments.ice_status_id") AND arguments.ice_status_id IS NOT 0>AND ice_status_id=#arguments.ice_status_id#</cfif>
<cfif isdefined("arguments.user_id") AND arguments.user_id IS NOT 0>AND ice_user_id=#arguments.user_id#</cfif>
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT  0>AND ice_site_id IN (#arguments.site_id#)</cfif>
            </cfquery>
<cfset countchannel=CountChannel.Recordcount>
		<cfreturn CountChannel>
	</cffunction>

	<cffunction name="getOtherChannel" access="public" output="false" returntype="query">
		<cfargument name="site_id" type="string" required="no" default="0">
		<cfargument name="channel_id" type="string" required="no" default="0">
		<cfargument name="fields" type="string" required="no" default="*">
            <cfquery datasource="#application.DB#" name="GetChannel">
                SELECT #arguments.fields# FROM ice_channel 
WHERE 0=0
<cfif isdefined("form.ice_channel_id") AND form.ice_channel_id IS NOT 0>AND id=#form.ice_channel_id#</cfif>
<cfif isdefined("arguments.channel_id") AND arguments.channel_id IS NOT 0>AND id = #arguments.channel_id#</cfif>
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT  0>AND ice_site_id IN (#arguments.site_id#)</cfif>
ORDER BY id ASC
            </cfquery>
		<cfreturn GetChannel>
	</cffunction>

	<cffunction name="getHomeChannel" access="public" output="false" returntype="query">
		<cfargument name="site_id" type="string" required="no" default="0">
		<cfargument name="fields" type="string" required="no" default="*">
            <cfquery datasource="#application.DB#" name="GetHomeChannel">
                SELECT #arguments.fields# FROM ice_channel 
WHERE 0=0 
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT 0>AND ice_site_id IN (#arguments.site_id#)</cfif>
AND ice_channel_type_id = 1
            </cfquery>
		<cfreturn GetHomeChannel>
	</cffunction>

	<cffunction name="getNewsChannel" access="public" output="false" returntype="query">
		<cfargument name="site_id" type="string" required="no" default="#session.current_site_id#">
		<cfargument name="fields" type="string" required="no" default="*">
            <cfquery datasource="#application.DB#" name="GetNewsChannel">
                SELECT #arguments.fields# FROM ice_channel 
WHERE 0=0 
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT 0>AND ice_site_id IN (#arguments.site_id#)</cfif>
AND ice_channel_type_id = 3
            </cfquery>
		<cfreturn GetNewsChannel>
	</cffunction>

	<cffunction name="publishChannel" access="public" output="false" returntype="numeric">
		<cfargument name="id" type="string" required="no" default="0">

<cftry>

<!--- Check Site Folder --->
<cfif session.current_site_folder IS NOT '' AND Isdefined("form.id") AND form.id IS NOT ''>
<cfset count=0>
<cfset session.formid=form.id>
<cfset session.published_file=form.published_file>
<cfloop list="#form.id#" index="dd">
<cfset formid=form.id>
<cfset count=count+1>
<cfoutput>
	<!--- Get Site Channels --->
	<cfquery datasource="#application.DB#" name="GetCF">
	SELECT id,folder,index_template,page_template,published_file,ice_channel_type_id FROM ice_channel WHERE id = #dd# AND folder IS NOT NULL AND ice_status_id=1 AND index_file IS NOT NULL AND page_file IS NOT NULL
	</cfquery>		
	
	<!--- Check Channel Folders --->
	<cfif GetCF.Recordcount IS NOT 0>

		<!--- Loop Channels --->
		<cfloop query="GetCF">

				<!--- Publish Channels --->

				<cfif listlen(listgetat(form.published_file,count),'.') IS 2 AND  listgetat(listgetat(form.published_file,count),2,".") IS 'cfm'>	
				<cfset contents='#replace(GetCF.index_template,"../","","ALL")#'>
				<cfelse>
				<CFHTTP URL="#application.ice_url#/sites/#session.current_site_folder#/index.cfm?cid=#GetCF.id#&sid=#session.current_site_id#" METHOD="get" RESOLVEURL="no"></CFHTTP>
				<cfset contents=cfhttp.filecontent>
				</cfif>				

				<cfif listgetat(form.published_file,count) IS NOT ''>
				<CFFILE ACTION="Write"  FILE="#application.ice_path#\sites\#session.current_site_folder#\#listgetat(form.published_file,count)#" OUTPUT="#contents#" attributes="normal" mode="777">
				<cfelse>
					<CFIF GetCF.ice_channel_type_id IS 1>
				<CFFILE ACTION="Write"  FILE="#application.ice_path#\sites\#session.current_site_folder#\home.cfm" OUTPUT="#contents#" attributes="normal" mode="777">
					<CFELSE>
				<CFFILE ACTION="Write"  FILE="#application.ice_path#\sites\#session.current_site_folder#\#GetCF.folder#.cfm" OUTPUT="#contents#" attributes="normal" mode="777">
					</CFIF>
				</cfif>

			<!--- Get Pages --->
			<cfquery datasource="#application.DB#" name="GetPage">
			SELECT id,ice_page,published_file FROM ice_page WHERE ice_site_id = #session.current_site_id# AND ice_channel_id=#GetCF.id# AND ice_status_id=1
			</cfquery>

				<!--- Check Pages --->
				<cfif GetPage.Recordcount IS NOT 0 AND GetCF.page_template IS NOT ''>

					<!--- Loop Pages --->
					<cfloop query="GetPage">

						<!--- Publish Pages --->
				<cfif listlen(GetPage.published_file,'.') IS 2 AND listgetat(GetPage.published_file,2,".") IS 'cfm'>
				<cfset contents ='#replace(GetCF.page_template,"../","","ALL")#'>
				<cfelse>	
				<CFHTTP URL="#application.ice_url#/sites/#session.current_site_folder#/page.cfm?id=#GetPage.id#&sid=#session.current_site_id#" METHOD="get" RESOLVEURL="no"></CFHTTP>
				<cfset contents=cfhttp.filecontent>
				</cfif>

				<cfif GetPage.published_file IS NOT ''>
				<CFFILE ACTION="Write"  FILE="#application.ice_path#\sites\#session.current_site_folder#\#GetPage.published_file#" OUTPUT="#contents#" attributes="normal" mode="777">
				<cfelse>
	<cfset y='#replace(lcase(GetPage.ice_page)," ","_","all")#'>
	<cfset y = replace(y,'?',"","all") />
	<cfset y = replace(y,'',"","all") />
	<cfset y = replace(y,".","","all") />
	<cfset y = replace(y,'',"","all") />
	<cfset y = replace(y,";","","all") />
	<cfset y = replace(y,"","","all") />
	<cfset y = replace(y,":","","all") />
	<cfset y = replace(y,"","","all") />
	<cfset y = replace(y,"!","","all") />
	<cfset y = replace(y,"","","all") />
	<cfset y = replace(y,"'","","all") />
	<cfset y = replace(y,"","","all") />
	<cfset y = replace(y,"##","","all") />
	<cfset y = replace(y,"(","","all") />
	<cfset y = replace(y,")","","all") />
				<CFFILE ACTION="Write"  FILE="#application.ice_path#\sites\#session.current_site_folder#\#y#.cfm" OUTPUT="#contents#" attributes="normal" mode="777">
				</cfif>
					</cfloop>

				</cfif>


<cfset pub='#listgetat(form.published_file,count)#'>
<!--- Save Publish Dates --->
<cfset form.id=GetCF.id>
<cfset form.published_file=pub>
<cfset form.published_date_d=now()>
<cfupdate tablename="ice_channel" datasource="#application.db#" formfields="id,published_date_d,published_file">
<cfset form.id=session.formid>
<cfset  form.published_file=session.published_file>
		</cfloop>

	</cfif>
</cfoutput>

</cfloop>

</cfif>

<cfcatch type="any"><cfset publishsite=0><cfreturn publishsite></cfcatch>
</cftry>	
		<cfset publishsite=1><cfreturn publishsite>
	</cffunction>


	<cffunction name="addChannel" access="public" output="false" returntype="numeric">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="fields" type="string" required="no" default="*">
<cfset form.ice_user_id=#session.user_id#>
<cfset form.ice_site_id=#session.current_site_id#>
<cfset form.folder=replacenocase(form.folder," ","_","ALL")>
<cfset form.created=now()>
<cftry>

<cfquery name="CheckFolder" datasource="#application.db#">
SELECT folder FROM ice_channel WHERE folder='#form.folder#' AND ice_site_id=#session.current_site_id#
</cfquery>

<CFIF CheckFolder.Recordcount IS 0>

<!--- Write to file --->
<CFFILE ACTION="write" OUTPUT="#form.index_template#" ADDNEWLINE="No" File="#application.ice_path#\sites\#session.current_site_folder#\channels\#form.folder#_index.cfm" charset="utf-8">
<CFFILE ACTION="write" OUTPUT="#form.page_template#" ADDNEWLINE="No" File="#application.ice_path#\sites\#session.current_site_folder#\channels\#form.folder#_page.cfm" charset="utf-8">
<!--- Set Filename --->
<cfset form.index_file='#form.folder#_index.cfm'>
<cfset form.page_file='#form.folder#_page.cfm'>
<!--- Write to file --->

<cfinsert tablename="ice_channel" datasource="#application.db#" formfields="#arguments.fields#,ice_user_id,ice_site_id,created,index_file,page_file">
<cfif form.ice_channel_type_id IS 1>
<cfquery name="GetHome" datasource="#application.db#" maxrows="1">
SELECT id FROM ice_channel WHERE ice_user_id=#form.ice_user_id# AND ice_site_id=#form.ice_site_id# ORDER BY id DESC
</cfquery>
<cfquery name="UpdateHome" datasource="#application.db#">
UPDATE ice_channel SET ice_channel_type_id=2 WHERE ice_site_id=#form.ice_site_id# AND id <> #GetHome.id#
</cfquery>
</cfif>
<CFELSE>
<cfset addchannel=0><cfreturn addchannel>
</CFIF>
<cfcatch type="any"><cfset addchannel=0><cfreturn addchannel></cfcatch>
</cftry>	
<cfset addchannel=1>
		<cfreturn addchannel>
	</cffunction>

	<cffunction name="updateChannel" access="public" output="false" returntype="numeric">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="fields" type="string" required="no" default="*">
<cftry>

<cfquery name="CheckFolder" datasource="#application.db#">
SELECT folder FROM ice_channel WHERE folder='#form.folder#' AND id <> #form.id# AND ice_site_id=#session.current_site_id#
</cfquery>

<CFIF CheckFolder.Recordcount IS 0>

<cfquery name="GetFiles" datasource="#application.db#">
SELECT index_file,page_file FROM ice_channel WHERE id = #form.id#
</cfquery>

<cfif GetFiles.index_file IS NOT ''>
<cffile action = "rename" destination = "#application.ice_path#\sites\#session.current_site_folder#\channels\bk_#GetFiles.index_file#" source = "#application.ice_path#\sites\#session.current_site_folder#\channels\#GetFiles.index_file#" attributes = "normal" mode = "777">
<cfelseif GetFiles.page_file IS NOT ''>
<cffile action = "rename" destination = "#application.ice_path#\sites\#session.current_site_folder#\channels\bk_#GetFiles.page_file#" source = "#application.ice_path#\sites\#session.current_site_folder#\channels\#GetFiles.page_file#" attributes = "normal" mode = "777">
</cfif>

<!--- Write to file --->
<CFFILE ACTION="write" OUTPUT="#form.index_template#" ADDNEWLINE="No" File="#application.ice_path#\sites\#session.current_site_folder#\channels\#form.folder#_index.cfm" charset="utf-8">
<CFFILE ACTION="write" OUTPUT="#form.page_template#" ADDNEWLINE="No" File="#application.ice_path#\sites\#session.current_site_folder#\channels\#form.folder#_page.cfm" charset="utf-8">
<!--- Write to file --->

<cfset form.index_file='#form.folder#_index.cfm'>
<cfset form.page_file='#form.folder#_page.cfm'>
<cfupdate tablename="ice_channel" datasource="#application.db#" formfields="id,#arguments.fields#,index_file,page_file">
<cfif form.ice_channel_type_id IS 1>
<cfquery name="UpdateHome" datasource="#application.db#">
UPDATE ice_channel SET ice_channel_type_id=2 WHERE ice_site_id=#session.current_site_id# AND id <> #form.id#
</cfquery>
</cfif>
<CFELSE>
<cfset updatechannel=0><cfreturn updatechannel>
</CFIF>
<cfcatch type="any"><cfset updatechannel=0><cfreturn updatechannel></cfcatch>
</cftry>	
<cfset updatechannel=1>
		<cfreturn updatechannel>

	</cffunction>

	<cffunction name="deleteChannel" access="public" output="false" returntype="numeric">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="id" type="string" required="no" default="0">
<CFIF Isdefined("url.confirm") AND url.confirm IS 'yes'>
<cftry>
<!--- GetChannel --->
<cfquery name="GetChannel" datasource="#application.db#">
SELECT * FROM ice_channel WHERE id IN (#arguments.id#)
</cfquery>

<!--- Delete Channel Templates --->
<cfif GetChannel.folder IS NOT ''>
	<cfloop query="GetChannel">
		<cfif fileexists("#application.ice_path#\sites\#session.current_site_folder#\channels\#folder#_index.cfm")>
		<cffile action="delete" file="#application.ice_path#\sites\#session.current_site_folder#\channels\#folder#_index.cfm">
		</cfif>

		<cfif fileexists("#application.ice_path#\sites\#session.current_site_folder#\channels\#folder#_page.cfm")>
		<cffile action="delete" file="#application.ice_path#\sites\#session.current_site_folder#\channels\#folder#_page.cfm">
		</cfif>
		
		<cfif directoryexists("#application.ice_path#\sites\#session.current_site_folder#\d\#folder#")>
		<cfdirectory action = "delete" directory = "#application.ice_path#\sites\#session.current_site_folder#\d\#folder#" recurse="yes">
		</cfif>
		<cfif  directoryexists("#application.ice_path#\sites\#session.current_site_folder#\s\#folder#")>
		<cfdirectory action = "delete" directory = "#application.ice_path#\sites\#session.current_site_folder#\s\#folder#" recurse="yes">
		</cfif>
		<cfif directoryexists("#application.ice_path#\sites\#session.current_site_folder#\p\#folder#")>
		<cfdirectory action = "delete" directory = "#application.ice_path#\sites\#session.current_site_folder#\p\#folder#" recurse="yes">		
		</cfif>

		<cfquery name="DeletePage" datasource="#application.db#">
		DELETE FROM ice_page WHERE ice_channel_id=#id#
		</cfquery>
	
	</cfloop>
</cfif>


<cfquery name="DeleteChannel" datasource="#application.db#">
DELETE FROM ice_channel WHERE id IN (#arguments.id#)
</cfquery>

<cfquery name="UpdateSubChannel" datasource="#application.db#">
UPDATE ice_channel SET ice_channel_id=0 WHERE ice_channel_id IN (#arguments.id#)
</cfquery>

<cfcatch type="any"><cfset deletechannel=0><cfreturn deletechannel></cfcatch>
</cftry>	
<cfset deletechannel=1>
<cfelse>
<cfset deletechannel=0><cfreturn deletechannel>
</cfif>
		<cfreturn deletechannel>
	</cffunction>

</cfcomponent>