﻿<cfcomponent>

	<cffunction name="getMessage" access="public" output="false" returntype="query">
		<cfargument name="fields" type="string" required="no" default="id">
            <cfquery datasource="#application.DB#" name="GetMessage">
                SELECT #arguments.fields# FROM ice_message 
WHERE 0=0 AND ice_message_status_id <> 3
<cfif isdefined("arguments.ice_user_id") AND arguments.ice_user_id IS NOT 0>AND ice_user_id=#arguments.ice_user_id#</cfif>
<cfif isdefined("arguments.ice_message_status_id") AND arguments.ice_message_status_id IS NOT 0>AND ice_message_status_id=#arguments.ice_message_status_id#</cfif>
ORDER BY ID DESC
            </cfquery>
		<cfreturn GetMessage>
	</cffunction>

	<cffunction name="sendMessage" access="public" output="false" returntype="numeric">
		<cfargument name="site_id" type="string" required="no" default="0">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="from_id" type="string" required="no" default="0">
		<cfargument name="message" type="string" required="no" default="0">
<cftry>
<cfset form.ice_from_id=arguments.from_id>
<cfset form.ice_message_status_id=1>
<cfset form.ice_site_id=session.current_site_id>
<cfset form.created=now()>
<cfinsert tablename="ice_message" formfields="ice_message,ice_user_id,ice_from_id,created,ice_site_id,ice_message_status_id" datasource="#application.db#">
<cfset send=1>
<cfreturn send>
<cfcatch type="any"><cfset send=0><cfreturn send></cfcatch>
</cftry>

	</cffunction>

	<cffunction name="deleteMessage" access="public" output="false" returntype="numeric">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="message_id" type="string" required="no" default="0">
<cftry>
<cfquery name="Del" datasource="#application.db#">
UPDATE ice_message SET ice_message_status_id=3 WHERE id=#arguments.message_id# AND ice_user_id=#arguments.user_id#
</cfquery>
<cfset del=1>
<cfreturn del>
<cfcatch type="any"><cfset del=0><cfreturn del></cfcatch>
</cftry>

	</cffunction>

	<cffunction name="changeMessageStatus" access="public" output="false" returntype="numeric">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="message_id" type="string" required="no" default="0">
		<cfargument name="status" type="string" required="no" default="0">
<cftry>
<cfquery name="Change" datasource="#application.db#">
UPDATE ice_message SET ice_message_status_id=#arguments.status# WHERE id=#arguments.message_id# AND ice_user_id=#arguments.user_id#
</cfquery>
<cfset change=1>
<cfreturn change>
<cfcatch type="any"><cfset change=0><cfreturn change></cfcatch>
</cftry>

	</cffunction>

	<cffunction name="countMessage" access="public" output="false" returntype="numeric">
		<cfargument name="fields" type="string" required="no" default="id">
            <cfquery datasource="#application.DB#" name="CountMessage">
                SELECT #arguments.fields# FROM ice_message 
WHERE 0=0 AND ice_message_status_id <> 3
<cfif isdefined("arguments.ice_message_status_id") AND arguments.ice_message_status_id IS NOT 0>AND ice_message_status_id=#arguments.ice_message_status_id#</cfif>
<cfif isdefined("arguments.from_id") AND arguments.from_id IS NOT 0>AND ice_from_id=#arguments.from_id#</cfif>
<cfif isdefined("arguments.user_id") AND arguments.user_id IS NOT 0>AND ice_user_id=#arguments.user_id#</cfif>
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT  0>AND ice_site_id IN (#arguments.site_id#)</cfif>
            </cfquery>
<cfset countmessage=CountMessage.Recordcount>
		<cfreturn CountMessage>
	</cffunction>
</cfcomponent>