<cfcomponent>
	<cffunction name="getPage" access="public" output="false" returntype="query">
		<cfargument name="page_id" type="string" required="no" default="0">
		<cfargument name="site_id" type="string" required="no" default="0">
		<cfargument name="ice_channel_id" type="string" required="no" default="0">
		<cfargument name="fields" type="string" required="no" default="*">
		<cfargument name="max" type="string" required="no" default="100000">
		<cfargument name="order_by" type="string" required="no" default="created DESC">
            <cfquery datasource="#application.DB#" name="GetPage" maxrows="#arguments.max#">
                SELECT #arguments.fields# FROM ice_page WHERE 0=0
<cfif isdefined("form.ice_page")>AND (ice_page LIKE '%#form.ice_page#%' OR body LIKE  '%#form.ice_page#%' OR summary LIKE  '%#form.ice_page#%')</cfif>
<cfif isdefined("form.ice_user_id") AND form.ice_user_id IS NOT 0>AND ice_user_id=#form.ice_user_id#</cfif>
<cfif isdefined("form.ice_status_id") AND form.ice_status_id IS NOT 0>AND ice_status_id=#form.ice_status_id#</cfif>
<cfif isdefined("form.ice_channel_id") AND form.ice_channel_id IS NOT 0>AND ice_channel_id=#form.ice_channel_id#</cfif>
<cfif isdefined("form.ice_site_language_id") AND form.ice_site_language_id IS NOT 0>AND ice_site_language_id=#form.ice_site_language_id#</cfif>
<cfif isdefined("arguments.page_id") AND arguments.page_id IS NOT 0>AND id IN (#arguments.page_id#)</cfif>
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT  0>AND ice_site_id IN (#arguments.site_id#)</cfif>
<cfif isdefined("arguments.id") AND arguments.id IS NOT  0>AND id = #arguments.id#</cfif>
<cfif isdefined("arguments.ice_status_id") AND arguments.ice_status_id IS NOT  0>AND ice_status_id IN (#arguments.ice_status_id#)</cfif>
<cfif isdefined("arguments.ice_channel_id") AND arguments.ice_channel_id IS NOT  0>AND FIND_IN_SET(#arguments.ice_channel_id#,ice_channel_id) <> 0</cfif>
<cfif isdefined("arguments.ice_site_language_id") AND arguments.ice_site_language_id IS NOT  0>AND ice_site_language_id = #arguments.ice_site_language_id#</cfif>
ORDER BY #arguments.order_by#
            </cfquery>
		<cfreturn GetPage>
	</cffunction>

	<cffunction name="getPageXML" access="public" output="false" returntype="xml">
		<cfargument name="page_id" type="string" required="no" default="0">
		<cfargument name="site_id" type="string" required="no" default="0">
		<cfargument name="ice_channel_id" type="string" required="no" default="0">
		<cfargument name="fields" type="string" required="no" default="*">
		<cfargument name="max" type="string" required="no" default="100000">
		<cfargument name="order_by" type="string" required="no" default="created DESC">
            <cfquery datasource="#application.DB#" name="GetPageXML" maxrows="#arguments.max#">
                SELECT #arguments.fields# FROM ice_page WHERE 0=0
<cfif isdefined("form.ice_page")>AND (ice_page LIKE '%#form.ice_page#%' OR body LIKE  '%#form.ice_page#%' OR summary LIKE  '%#form.ice_page#%')</cfif>
<cfif isdefined("form.ice_user_id") AND form.ice_user_id IS NOT 0>AND ice_user_id=#form.ice_user_id#</cfif>
<cfif isdefined("form.ice_status_id") AND form.ice_status_id IS NOT 0>AND ice_status_id=#form.ice_status_id#</cfif>
<cfif isdefined("form.ice_channel_id") AND form.ice_channel_id IS NOT 0>AND ice_channel_id=#form.ice_channel_id#</cfif>
<cfif isdefined("form.ice_site_language_id") AND form.ice_site_language_id IS NOT 0>AND ice_site_language_id=#form.ice_site_language_id#</cfif>
<cfif isdefined("arguments.page_id") AND arguments.page_id IS NOT 0>AND id IN (#arguments.page_id#)</cfif>
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT  0>AND ice_site_id IN (#arguments.site_id#)</cfif>
<cfif isdefined("arguments.id") AND arguments.id IS NOT  0>AND id = #arguments.id#</cfif>
<cfif isdefined("arguments.ice_status_id") AND arguments.ice_status_id IS NOT  0>AND ice_status_id IN (#arguments.ice_status_id#)</cfif>
<cfif isdefined("arguments.ice_channel_id") AND arguments.ice_channel_id IS NOT  0>AND FIND_IN_SET(#arguments.ice_channel_id#,ice_channel_id) <> 0</cfif>
<cfif isdefined("arguments.ice_site_language_id") AND arguments.ice_site_language_id IS NOT  0>AND ice_site_language_id = #arguments.ice_site_language_id#</cfif>
ORDER BY #arguments.order_by#
            </cfquery>

		<cfif GetPageXML.RecordCount IS 0>
<cfxml variable="XMLResult">
<page>
<result>None found!</result>
</page>
</cfxml>	
		<cfelse>
<cfprocessingdirective suppresswhitespace="Yes">
<cfxml variable="XMLResult">
<ice>
<cfoutput query="GetPageXML">
<page><id>#id#</id>
<ice_page>#ice_page#</ice_page>
<ice_site_id>#ice_site_id#</ice_site_id>
<cfinvoke component="site" method="getSites" site_id="#ice_site_id#" fields="ice_site,folder"  returnvariable="site">
<ice_site>#site.ice_site#</ice_site>
<ice_user_id>#ice_user_id#</ice_user_id>
<cfinvoke component="user" method="getUser" user_id="#ice_user_id#" fields="ice_user,photo"  returnvariable="user">
<ice_user>#user.ice_user#</ice_user>
<photo>#application.ice_url#/photos/#user.photo#</photo>
<ice_channel_id>#ice_channel_id#</ice_channel_id>
<cfinvoke component="channel" method="getOtherChannel" channel_id="#ice_channel_id#" fields="ice_channel,folder,published_file,ice_channel_type_id,ice_channel_id"  returnvariable="channel">
<ice_channel>#channel.ice_channel#</ice_channel>
<channel_folder>#channel.folder#</channel_folder>
<cfif channel.ice_channel_type_id IS 1>
<channel_published_file>#application.ice_url#/sites/#site.folder#/p/#channel.published_file#</channel_published_file>
<cfelse>
<channel_published_file>#application.ice_url#/sites/#site.folder#/p/#channel.folder#/#channel.published_file#</channel_published_file>
</cfif>
<cfinvoke component="channel" method="getChannel" parent_channel_id="#channel.ice_channel_id#" fields="ice_channel,folder,published_file,ice_channel_type_id"  site_id="0" returnvariable="parentchannel">
<CFIF parentchannel.recordcount IS 1>
<parent_channel>#parentchannel.ice_channel#</parent_channel>
<parent_channel_folder>#parentchannel.folder#</parent_channel_folder>
<cfif parentchannel.ice_channel_type_id IS 1>
<parent_channel_published_file>#application.ice_url#/sites/#site.folder#/p/#parentchannel.published_file#</parent_channel_published_file>
<cfelse>
<parent_channel_published_file>#application.ice_url#/sites/#site.folder#/p/#parentchannel.folder#/#parentchannel.published_file#</parent_channel_published_file>
</cfif>
<CFELSE>
<parent_channel></parent_channel>
<parent_channel_folder></parent_channel_folder>
<parent_channel_published_file></parent_channel_published_file>
</CFIF>
<summary>#XMLFormat(summary)#</summary>
<body>#XMLFormat(body)#</body>
<link_text>#link_text#</link_text>
<meta_title>#meta_title#</meta_title>
<meta_keyword>#meta_keyword#</meta_keyword>
<meta_description>#meta_description#</meta_description>
<anchor_text>#anchor_text#</anchor_text>
<rank>#rank#</rank>
<created>#created#</created>
<published_file>#application.ice_url#/sites/#site.folder#/p/#channel.folder#/#published_file#</published_file>
<published_date_d>#published_date_d#</published_date_d>
<published_date_s>#published_date_s#</published_date_s>
<published_date_p>#published_date_p#</published_date_p>
<ice_status_id>#ice_status_id#</ice_status_id>
<cfset media='image,flash,video,audio,document'>
<cfloop list="#media#" index="m">
<cfinvoke component="page_#m#" method="getPage#m#" page_id="#id#" returnvariable="page_#m#_id">
<cfset p='page_#m#_id'>

<cfinvoke component="#m#" method="getsite#m#" id="#evaluate(p)#" ice_status_id="1" ice_site_id="#ice_site_id#" returnvariable="page_#m#">

<cfset tag='page_#m#'>
<cfif evaluate(tag).recordcount IS NOT 0>
<#tag#>
<cfloop query="#tag#">
<cfset nm='ice_#m#'>
<#m#_name>#evaluate(nm)#</#m#_name>
<#m#_caption>#caption#</#m#_caption>
<#m#_file>#application.ice_url#/sites/#site.folder#/<cfif m is 'image' OR m IS 'video'>#m#s<cfelseif m IS 'document'>docs<cfelse>#m#</cfif>/#file#</#m#_file>
<cfif m IS 'image'>
<#m#_alt_text>#alt_text#</#m#_alt_text>

<cfelseif m IS 'video'>
<#m#_embed_code>#embed_code#</#m#_embed_code>

</cfif>
</cfloop>
</#tag#>
</cfif>
</cfloop>
</page>
</cfoutput>
</ice>
</cfxml>	
</cfprocessingdirective>
		</cfif>
		<cfreturn XMLResult>
	</cffunction>

	<cffunction name="countPage" access="public" output="false" returntype="numeric">
		<cfargument name="fields" type="string" required="no" default="id">
            <cfquery datasource="#application.DB#" name="CountPage">
                SELECT #arguments.fields# FROM ice_page 
WHERE 0=0
<cfif isdefined("arguments.ice_status_id") AND arguments.ice_status_id IS NOT 0>AND ice_status_id=#arguments.ice_status_id#</cfif>
<cfif isdefined("arguments.user_id") AND arguments.user_id IS NOT 0>AND ice_user_id=#arguments.user_id#</cfif>
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT  0>AND ice_site_id IN (#arguments.site_id#)</cfif>
            </cfquery>
<cfset countpage=CountPage.Recordcount>
		<cfreturn CountPage>
	</cffunction>

	<cffunction name="addPage" access="public" output="false" returntype="numeric">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="fields" type="string" required="no" default="*">
<cfset form.ice_user_id=#session.user_id#>
<cfset form.created=now()>
<cfset form.ice_site_id=session.current_site_id>
<cftry>
<cfinsert tablename="ice_page" datasource="#application.db#" formfields="#arguments.fields#,ice_user_id,created,ice_site_id">
            <cfquery datasource="#application.DB#" name="PageID" maxrows="1">
SELECT id FROM ice_page WHERE ice_user_id=#form.ice_user_id# AND ice_site_id=#form.ice_site_id# ORDER BY id DESC
           </cfquery>

<cfif isdefined("form.image") AND form.image IS NOT 0>
	<cfloop list="#form.image#" index="im">
<cfset form.ice_page_id=#PageID.id#>
<cfset form.ice_image_id=#im#>
<cfinsert tablename="ice_page_image" datasource="#application.db#" formfields="ice_page_id,ice_image_id">	
	</cfloop>	
</cfif>

<cfif isdefined("form.flash") AND form.flash IS NOT 0>
	<cfloop list="#form.flash#" index="im">
<cfset form.ice_page_id=#PageID.id#>
<cfset form.ice_flash_id=#im#>
<cfinsert tablename="ice_page_flash" datasource="#application.db#" formfields="ice_page_id,ice_flash_id">	
	</cfloop>	
</cfif>

<cfif isdefined("form.video") AND form.video IS NOT 0>
	<cfloop list="#form.video#" index="im">
<cfset form.ice_page_id=#PageID.id#>
<cfset form.ice_video_id=#im#>
<cfinsert tablename="ice_page_video" datasource="#application.db#" formfields="ice_page_id,ice_video_id">	
	</cfloop>	
</cfif>

<cfif isdefined("form.document") AND form.document IS NOT 0>
	<cfloop list="#form.document#" index="im">
<cfset form.ice_page_id=#PageID.id#>
<cfset form.ice_document_id=#im#>
<cfinsert tablename="ice_page_document" datasource="#application.db#" formfields="ice_page_id,ice_document_id">	
	</cfloop>	
</cfif>

<cfif isdefined("form.audio") AND form.audio IS NOT 0>
	<cfloop list="#form.audio#" index="im">
<cfset form.ice_page_id=#PageID.id#>
<cfset form.ice_audio_id=#im#>
<cfinsert tablename="ice_page_audio" datasource="#application.db#" formfields="ice_page_id,ice_audio_id">	
	</cfloop>	
</cfif>

<cfcatch type="any"><cfset addpage=0><cfreturn addpage></cfcatch>
</cftry>	
<cfset addpage=1>
		<cfreturn addpage>
	</cffunction>

	<cffunction name="updatePage" access="public" output="false" returntype="numeric">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="fields" type="string" required="no" default="*">
<!---<cftry>--->
<cfupdate tablename="ice_page" datasource="#application.db#" formfields="id,#arguments.fields#">

<!--- Handle Media --->
<cfif isdefined("form.image") AND form.image IS NOT 0>
            		<cfquery datasource="#application.DB#" name="DelMedia">
		DELETE FROM ice_page_image WHERE ice_page_id=#form.id# AND ice_image_id NOT IN ('#form.image#')
		</cfquery>
	<cfloop list="#form.image#" index="im">
		 <cfquery datasource="#application.DB#" name="CheckMedia">
		SELECT id FROM ice_page_image WHERE ice_page_id=#form.id# AND ice_image_id = #im#
		</cfquery>
<cfif CheckMedia.Recordcount IS 0>
<cfset form.ice_page_id=#form.id#>
<cfset form.ice_image_id=#im#>
<cfinsert tablename="ice_page_image" datasource="#application.db#" formfields="ice_page_id,ice_image_id">
</cfif>	
	</cfloop>
<cfelse>
            		<cfquery datasource="#application.DB#" name="DelMedia">
		DELETE FROM ice_page_image WHERE ice_page_id=#form.id#
		</cfquery>	
</cfif>

<cfif isdefined("form.flash") AND form.flash IS NOT 0>
            		<cfquery datasource="#application.DB#" name="DelMedia">
		DELETE FROM ice_page_flash WHERE ice_page_id=#form.id# AND ice_flash_id NOT IN ('#form.flash#')
		</cfquery>
	<cfloop list="#form.flash#" index="im">
		 <cfquery datasource="#application.DB#" name="CheckMedia">
		SELECT id FROM ice_page_flash WHERE ice_page_id=#form.id# AND ice_flash_id = #im#
		</cfquery>
<cfif CheckMedia.Recordcount IS 0>
<cfset form.ice_page_id=#form.id#>
<cfset form.ice_flash_id=#im#>
<cfinsert tablename="ice_page_flash" datasource="#application.db#" formfields="ice_page_id,ice_flash_id">
</cfif>	
	</cfloop>	
<cfelse>
            		<cfquery datasource="#application.DB#" name="DelMedia">
		DELETE FROM ice_page_flash WHERE ice_page_id=#form.id#
		</cfquery>
</cfif>

<cfif isdefined("form.video") AND form.video IS NOT 0>
            		<cfquery datasource="#application.DB#" name="DelMedia">
		DELETE FROM ice_page_video WHERE ice_page_id=#form.id# AND ice_video_id NOT IN ('#form.video#')
		</cfquery>
	<cfloop list="#form.video#" index="im">
		 <cfquery datasource="#application.DB#" name="CheckMedia">
		SELECT id FROM ice_page_video WHERE ice_page_id=#form.id# AND ice_video_id = #im#
		</cfquery>
<cfif CheckMedia.Recordcount IS 0>
<cfset form.ice_page_id=#form.id#>
<cfset form.ice_video_id=#im#>
<cfinsert tablename="ice_page_video" datasource="#application.db#" formfields="ice_page_id,ice_video_id">
</cfif>	
	</cfloop>	
<cfelse>
            		<cfquery datasource="#application.DB#" name="DelMedia">
		DELETE FROM ice_page_video WHERE ice_page_id=#form.id#
		</cfquery>
</cfif>

<cfif isdefined("form.document") AND form.document IS NOT 0>
            		<cfquery datasource="#application.DB#" name="DelMedia">
		DELETE FROM ice_page_document WHERE ice_page_id=#form.id# AND ice_document_id NOT IN ('#form.document#')
		</cfquery>
	<cfloop list="#form.document#" index="im">
		 <cfquery datasource="#application.DB#" name="CheckMedia">
		SELECT id FROM ice_page_document WHERE ice_page_id=#form.id# AND ice_document_id = #im#
		</cfquery>
<cfif CheckMedia.Recordcount IS 0>
<cfset form.ice_page_id=#form.id#>
<cfset form.ice_document_id=#im#>
<cfinsert tablename="ice_page_document" datasource="#application.db#" formfields="ice_page_id,ice_document_id">
</cfif>	
	</cfloop>	
<cfelse>
            		<cfquery datasource="#application.DB#" name="DelMedia">
		DELETE FROM ice_page_document WHERE ice_page_id=#form.id#
		</cfquery>
</cfif>

<cfif isdefined("form.audio") AND form.audio IS NOT 0>
            		<cfquery datasource="#application.DB#" name="DelMedia">
		DELETE FROM ice_page_audio WHERE ice_page_id=#form.id# AND ice_audio_id NOT IN ('#form.audio#')
		</cfquery>
	<cfloop list="#form.audio#" index="im">
		 <cfquery datasource="#application.DB#" name="CheckMedia">
		SELECT id FROM ice_page_audio WHERE ice_page_id=#form.id# AND ice_audio_id = #im#
		</cfquery>
<cfif CheckMedia.Recordcount IS 0>
<cfset form.ice_page_id=#form.id#>
<cfset form.ice_audio_id=#im#>
<cfinsert tablename="ice_page_audio" datasource="#application.db#" formfields="ice_page_id,ice_audio_id">
</cfif>	
	</cfloop>	
<cfelse>
            		<cfquery datasource="#application.DB#" name="DelMedia">
		DELETE FROM ice_page_audio WHERE ice_page_id=#form.id#
		</cfquery>
</cfif>
<!--- Handle Media --->
<!---
<cfcatch type="any"><cfset updatepage=0><cfreturn updatepage></cfcatch>
</cftry>
--->	
<cfset updatepage=1>
		<cfreturn updatepage>

	</cffunction>


	<cffunction name="publishPage" access="public" output="false" returntype="numeric">
		<cfargument name="id" type="string" required="no" default="0">

<cftry>

<!--- Check Site Folder --->
<cfset session.pf='#form.published_file#'>
<cfif session.current_site_folder IS NOT '' AND Isdefined("form.id") AND form.id IS NOT ''>
	<cfset count=0>
<cfset session.formid=form.id>

		<!--- Loop Form Pages --->
		<cfloop list="#form.id#" index="pageid">
	<cfset count = count+1>
			<!--- Get Page Channels --->
			<cfquery datasource="#application.DB#" name="GetPCID">
			SELECT ice_page.id,ice_page.published_file, ice_channel.id,ice_channel.folder,ice_channel.index_template,ice_channel.page_template,ice_channel.published_file,ice_channel.ice_channel_type_id FROM ice_page,ice_channel WHERE ice_page.id = #pageid# AND ice_page.ice_status_id=1 AND ice_page.ice_channel_id=ice_channel.id 
			</cfquery>

<!--- Get Channel Info --->
<cfif GetPCID.Recordcount IS NOT 0>
	<!--- Write Pages --->
	<cfif len(listgetat(form.published_file,count)) AND listgetat(listgetat(form.published_file,count),2,".") IS 'cfm'>
		<cfset cfhttp.filecontent='#replace(GetPCID.page_template,"../","","ALL")#'>
	<cfelseif listlen(GetPCID.published_file,'.' IS 2) AND listgetat(GetPCID.published_file,2,".") IS 'cfm'>
		<cfset cfhttp.filecontent='#GetPCID.page_template#'>
	<cfelse>
		<CFHTTP URL="#application.ice_url#/sites/#session.current_site_folder#/page.cfm?pid=#pageid#&cid=#GetPCID.ice_channel.id#&sid=#session.current_site_id#" METHOD="get" RESOLVEURL="no"></CFHTTP>
	</cfif>
		<CFFILE ACTION="Write"  FILE="#application.ice_path#\sites\#session.current_site_folder#\#listgetat(session.pf, count, ',')#" OUTPUT="#cfhttp.FileContent#" attributes="normal" mode="777">

		<cfset form.id=getpcid.id>
		<cfset form.published_file=listgetat(session.pf, count, ',')>

<cfset form.published_date_d=now()>
<cfupdate tablename="ice_page" datasource="#application.db#" formfields="id,published_date_d,published_file">
						
</cfif>
			<cfset form.published_file=session.pf>
			<cfset form.id=session.formid>				
		</cfloop>
<cfelse>
	<cfset publishsite=0><cfreturn publishsite>
</cfif>
<cfcatch type="any"><cfset publishsite=0><cfreturn publishsite></cfcatch>
</cftry>

		<cfset publishsite=1><cfreturn publishsite>
	</cffunction>

	<cffunction name="deletePage" access="public" output="false" returntype="numeric">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="id" type="string" required="no" default="0">
<CFIF  Isdefined("url.confirm") AND url.confirm IS 'yes'>
<cftry>

<cfquery name="GetPage" datasource="#application.db#">
SELECT * FROM ice_page WHERE id IN (#arguments.id#)
</cfquery>

<cfif GetPage.recordcount IS NOT 0>
	<cfloop query="GetPage">
		<cfif GetPage.Published_File IS NOT ''>
<cfquery name="GetFolder" datasource="#application.db#">
SELECT folder,ice_channel_type_id FROM ice_channel WHERE id = #GetPage.ice_channel_id#
</cfquery>
			<cfif fileexists("#application.ice_path#\sites\#session.current_site_folder#\d\#getfolder.folder#\#GetPage.published_file#")>
			<cffile action="delete" file="#application.ice_path#\sites\#session.current_site_folder#\d\#getfolder.folder#\#GetPage.published_file#">
			</cfif>
			<cfif fileexists("#application.ice_path#\sites\#session.current_site_folder#\s\#getfolder.folder#\#GetPage.published_file#")>
			<cffile action="delete" file="#application.ice_path#\sites\#session.current_site_folder#\s\#getfolder.folder#\#GetPage.published_file#">
			</cfif>
			<cfif fileexists("#application.ice_path#\sites\#session.current_site_folder#\p\#getfolder.folder#\#GetPage.published_file#")>
			<cffile action="delete" file="#application.ice_path#\sites\#session.current_site_folder#\p\#getfolder.folder#\#GetPage.published_file#">
			</cfif>			
		</cfif>
	</cfloop>
</cfif>

<cfquery name="DeletePage" datasource="#application.db#">
DELETE FROM ice_page WHERE id IN (#arguments.id#)
</cfquery>

<cfcatch type="any"><cfset deletepage=0><cfreturn deletepage></cfcatch>
</cftry>	
<cfset deletepage=1>
<cfelse>
<cfset deletepage=0><cfreturn deletepage>
</cfif>
		<cfreturn deletepage>

	</cffunction>
</cfcomponent>
