<cfcomponent>

	<cffunction name="getTask" access="public" output="false" returntype="query">
		<cfargument name="fields" type="string" required="no" default="id">
		<cfargument name="site_id" type="string" required="no" default="#session.current_site_id#">
            <cfquery datasource="#application.DB#" name="GetTask">
                SELECT #arguments.fields# FROM ice_task 
WHERE 0=0 AND ice_task_status_id <> 3
<cfif isdefined("arguments.ice_user_id") AND arguments.ice_user_id IS NOT 0>AND (ice_user_id=#arguments.ice_user_id# OR ice_from_id=#arguments.ice_user_id#)</cfif>
<cfif isdefined("arguments.ice_task_status_id") AND arguments.ice_task_status_id IS NOT 0>AND ice_task_status_id=#arguments.ice_task_status_id#</cfif>
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT 0>AND ice_site_id=#arguments.site_id#</cfif>
ORDER BY ID DESC
            </cfquery>

		<cfreturn GetTask>
	</cffunction>

	<cffunction name="countTask" access="public" output="false" returntype="numeric">
		<cfargument name="fields" type="string" required="no" default="id">
            <cfquery datasource="#application.DB#" name="CountTask">
                SELECT #arguments.fields# FROM ice_task 
WHERE 0=0
<cfif isdefined("arguments.ice_task_status_id") AND arguments.ice_task_status_id IS NOT 0>AND ice_task_status_id=#arguments.ice_task_status_id#</cfif>
<cfif isdefined("arguments.user_id") AND arguments.user_id IS NOT 0>AND ice_user_id=#arguments.user_id#</cfif>
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT  0>AND ice_site_id IN (#arguments.site_id#)</cfif>

            </cfquery>
<cfset counttask=CountTask.Recordcount>
		<cfreturn CountTask>
	</cffunction>

	<cffunction name="changeTaskStatus" access="public" output="false" returntype="numeric">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="task_id" type="string" required="no" default="0">
		<cfargument name="status" type="string" required="no" default="0">
<cftry>
<cfquery name="Change" datasource="#application.db#">
UPDATE ice_task SET ice_task_status_id=#arguments.status# WHERE id=#arguments.task_id# AND ice_user_id=#arguments.user_id#
</cfquery>
<cfset change=1>
<cfreturn change>
<cfcatch type="any"><cfset change=0><cfreturn change></cfcatch>
</cftry>

	</cffunction>

	<cffunction name="deleteTask" access="public" output="false" returntype="numeric">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="task_id" type="string" required="no" default="0">
<cftry>
<cfquery name="Del" datasource="#application.db#">
UPDATE ice_task SET ice_task_status_id=3 WHERE id=#arguments.task_id# AND ice_user_id=#arguments.user_id#
</cfquery>
<cfset del=1>
<cfreturn del>
<cfcatch type="any"><cfset del=0><cfreturn del></cfcatch>
</cftry>

	</cffunction>

	<cffunction name="sendTask" access="public" output="false" returntype="numeric">
		<cfargument name="site_id" type="string" required="no" default="0">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="from_id" type="string" required="no" default="0">
		<cfargument name="task" type="string" required="no" default="0">
<cftry>
<cfset form.ice_from_id=arguments.from_id>
<cfset form.ice_task_status_id=1>
<cfset form.ice_site_id=session.current_site_id>
<cfset form.created=now()>
<cfinsert tablename="ice_task" formfields="ice_task,ice_user_id,ice_from_id,created,ice_site_id,ice_task_status_id" datasource="#application.db#">
<cfset send=1>
<cfreturn send>
<cfcatch type="any"><cfset send=0><cfreturn send></cfcatch>
</cftry>

	</cffunction>

</cfcomponent>